﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Bots.Gatherbuddy;
using Styx;
using Styx.Common;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace GB2DynBlacklist
{
  public class GB2DynBlacklistPlugin : HBPlugin
  {
    #region Globals

    public override string Name { get { return "GB2DynBlacklist"; } }
    public override string Author { get { return "DarK"; } }
    public override Version Version { get { return new Version(0, 1, 0, 0); } }
    public override string ButtonText { get { return "Open Data Form"; } }
    public override bool WantButton { get { return true; } }
    private static LocalPlayer Me { get { return StyxWoW.Me; } }

    #endregion

    public float MaxDistance = 15.0f;
    public int MinMobCount = 1;
    public uint MinMobsHealthSum;

    class BlacklistItem
    {
      public WoWPoint Point;
      public DateTime StartTime = DateTime.Now;

      public BlacklistItem(WoWPoint point)
      {
        Point = point;
      }
    }
    private List<BlacklistItem> blacklistedByMe = new List<BlacklistItem>();

    public override void Pulse()
    {
      WoWGameObject[] gatherNodes = ObjectManager.GetObjectsOfType<WoWGameObject>().Where(o => o.IsHerb || o.IsMineral).ToArray();
      for(int i = 0; i<gatherNodes.Length; i++)
      {
        WoWGameObject node = gatherNodes[i];
        WoWUnit[] hostileMobs = ObjectManager.GetObjectsOfType<WoWUnit>().Where(o => o.IsAlive && o.IsHostile && o.Location.Distance2D(node.Location) <= MaxDistance).ToArray();
        long sumHealth = hostileMobs.Sum(o => o.CurrentHealth);
        if(hostileMobs.Length >= MinMobCount)
        {
          if (!GatherbuddyBot.BlacklistNodes.Contains(node.Location))
          {
            GatherbuddyBot.BlacklistNodes.Add(node.Location);
            blacklistedByMe.Add(new BlacklistItem(node.Location));
            Logging.Write("[GB2DBL] Blacklisted node " + node.Location);
          }
        }
        else
        {
          BlacklistItem item = blacklistedByMe.Find(o => o.Point == node.Location);
          if (item!=null && item.StartTime < DateTime.Now.AddMinutes(-5))
          {
            GatherbuddyBot.BlacklistNodes.Remove(node.Location);
            blacklistedByMe.Remove(item);
            Logging.Write("[GB2DBL] Whitelisted node back " + node.Location);
          }
        }
      }
    }

    public override void OnButtonPress()
    {
    }
  }
}
